import React, { CSSProperties } from 'react';
import { Placement, HighlightClasses } from '../../element-highlighter';
export interface HoverHighlighterProps extends React.HTMLAttributes<HTMLDivElement> {
    disabled?: boolean;
    /** default pop location for the label */
    placement?: Placement;
    /** customize styles */
    classes?: HighlightClasses;
    /** customize highlighter */
    highlightStyle?: CSSProperties;
    /** debounces element hover selection.
     * A higher value will reduce element lookups as well as "keep" the highlight on the current element for longer.
     * Initial selection (when no element is currently selected) will always happen immediately to improve the user experience.
     * @default 80ms
     */
    debounceSelection?: number;
    /** continually update frame position to match moving elements */
    watchMotion?: boolean;
}
/** automatically highlight components on hover */
export declare function HoverHighlighter({ children, disabled, classes, highlightStyle, placement, debounceSelection, watchMotion, ...rest }: HoverHighlighterProps): JSX.Element;
