"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiHighlighter = void 0;
const react_1 = __importStar(require("react"));
const get_xpath_1 = __importDefault(require("get-xpath"));
const react_ui_component_highlighter_1 = require("@teambit/react.ui.component-highlighter");
const react_modules_dom_to_react_1 = require("@teambit/react.modules.dom-to-react");
const react_ui_highlighter_component_metadata_bit_component_meta_1 = require("@teambit/react.ui.highlighter.component-metadata.bit-component-meta");
const ignore_highlighter_1 = require("../ignore-highlighter");
// TODO - reuse selector from @teambit/react.ui.component-highlighter
const allExceptHighlighterQuery = `:not(${ignore_highlighter_1.excludeHighlighterSelector}, ${ignore_highlighter_1.excludeHighlighterSelector} *)`;
function MultiHighlighter(_a) {
    var { children, disabled, watchMotion = false, style, bgColor, bgColorActive, bgColorHover, highlighterOptions } = _a, rest = __rest(_a, ["children", "disabled", "watchMotion", "style", "bgColor", "bgColorActive", "bgColorHover", "highlighterOptions"]);
    const ref = (0, react_1.createRef)();
    const [targets, setTargets] = (0, react_1.useState)({});
    (0, react_1.useEffect)(() => {
        if (disabled) {
            setTargets({});
            return;
        }
        const { current } = ref;
        if (!current)
            return;
        // select all non-highlighter elements
        const allElements = Array.from(current.querySelectorAll(allExceptHighlighterQuery));
        // converge on the root element of components
        const rootElements = allElements.map(react_modules_dom_to_react_1.toRootElement).filter((x) => !!x);
        // deduplicate
        const uniqueRoots = new Set(rootElements);
        const nextTargets = {};
        uniqueRoots.forEach((element) => {
            const comp = (0, react_modules_dom_to_react_1.domToReact)(element);
            if (!element || !(0, react_ui_highlighter_component_metadata_bit_component_meta_1.hasComponentMeta)(comp))
                return;
            const key = (0, get_xpath_1.default)(element);
            // eslint-disable-next-line no-underscore-dangle
            nextTargets[key] = { element, id: comp.__bit_component.id };
        });
        setTargets(nextTargets);
    }, [disabled]);
    const colors = {
        '--bit-highlighter-color': bgColor,
        '--bit-highlighter-color-hover': bgColorHover,
        '--bit-highlighter-color-active': bgColorActive,
    };
    return (react_1.default.createElement("div", Object.assign({ ref: ref }, rest, { style: Object.assign(Object.assign({}, colors), style) }),
        children,
        Object.entries(targets).map(([key, target]) => (react_1.default.createElement(react_ui_component_highlighter_1.ElementHighlighter, Object.assign({ key: key, target: target, watchMotion: watchMotion }, highlighterOptions))))));
}
exports.MultiHighlighter = MultiHighlighter;
//# sourceMappingURL=multi-highlighter.js.map